NETSTAT(1)

NAME
netstat - show network status

SYNOPSIS
netstat [-Aan] [-f address_family] [-M core] [-N system]
[-dghimnrs] [-f address_family] [-M core] [-N system]
[-dn] [-I interface] [-M core] [-N system] [-w wait]
[-p protocol] [-M core] [-N system]

DESCRIPTION
The netstat command symbolically displays the contents of various network-related data structures. There are a number of output formats, depending on the options for the information presented. The first form of the command displays a list of active sockets for each protocol. The second form presents the contents of one of the other network data structures according to the option selected. Using the third form, with a wait interval specified, netstat will continuously display the information regarding packet traffic on the configured network interfaces. The fourth form displays statistics about the named protocol.

The options have the following meaning:

-A  With the default display, show the address of any protocol control blocks associated with sockets; used for debugging.

-a  With the default display, show the state of all sockets; normally sockets used by server processes are not shown.

-d  With either interface display (option -i or an interval, as described below), show the number of dropped packets.

-f address_family
    Limit statistics or address control block reports to those of the specified address family. The following address families are recognized: inet, for AF_INET; ns, for AF_NS; iso, for AF_ISO; atalk, for AF_APPLETALK; and unix, for AF_UNIX.

-g  Show information related to multicast (group address) routing. By default, show the IP Multicast virtual-interface and routing tables. If the -s option is also present, show multicast routing statistics.

-h  Show the state of the IMP host table (obsolete).

-I interface
    Show information about the specified interface; used with a wait interval as described below.

-i  Show the state of interfaces which have been auto-configured (interfaces statically configured into a system, but not located at boot time are not shown). If the -a options is also present, multicast addresses currently in use are shown for each Ethernet interface and for each IP interface address. Multicast addresses are shown on separate lines following the interface address with which they are associated.

-M  Extract values associated with the name list from the specified core instead of the default /dev/kmem.

-m  Show statistics recorded by the memory management routines (the network manages a private pool of memory buffers).

-N  Extract the name list from the specified system instead of the default /netbsd.

-n  Show network addresses as numbers (normally netstat interprets addresses and attempts to display them symbolically). This option may be used with any of the display formats.

-p protocol
    Show statistics about protocol, which is either a well-known name for a protocol or an alias for it. Some protocol names and aliases are listed in the file /etc/protocols. A null response typically means that there are no interesting numbers to report. The program will complain if protocol is unknown or if there is no statistics routine for it.

-s  Show per-protocol statistics. If this option is repeated, counters with a value of zero are suppressed.

-r  Show the routing tables. When -s is also present, show routing statistics instead.

-w wait
    Show network interface statistics at intervals of wait seconds.

The default display, for active sockets, shows the local and remote addresses, send and receive queue sizes (in bytes), protocol, and the internal state of the protocol. Address formats are of the form ``host.port'' or ``network.port'' if a socket's address specifies a network but no specific host address. When known the host and network addresses are displayed symbolically according to the data bases /etc/hosts and /etc/networks, respectively. If a symbolic name for an address is unknown, or if the -n option is specified, the address is printed numerically, according to the address family. For more information regarding the Internet ``dot format,'' refer to inet(3)). Unspecified, or ``wildcard'', addresses and ports appear as ``*''.

The interface display provides a table of cumulative statistics regarding packets transferred, errors, and collisions. The network addresses of the interface and the maximum transmission unit (``mtu'') are also displayed.

The routing table display indicates the available routes and their status. Each route consists of a destination host or network and a gateway to use in forwarding packets. The flags field shows a collection of information about the route stored as binary choices. The individual flags are discussed in more detail in the route(8) and route(4) manual pages. The mapping between letters and flags is:
1 RTF_PROTO2 Protocol specific routing flag #1 2 RTF_PROTO1 Protocol specific routing flag #2 B RTF_BLACKHOLE Just discard pkts (during updates) C RTF_CLONING Generate new routes on use D RTF_DYNAMIC Created dynamically (by redirect) G RTF_GATEWAY Destination requires forwarding by intermediary H RTF_HOST Host entry (net otherwise) L RTF_LLINFO Valid protocol to link address translation. M RTF_MODIFIED Modified dynamically (by redirect) R RTF_REJECT Host or net unreachable S RTF_STATIC Manually added U RTF_UP Route usable X RTF_XRESOLVE External daemon translates proto to link address

Direct routes are created for each interface attached to the local host; the gateway field for such entries shows the address of the outgoing interface. The refcnt field gives the current number of active uses of the route. Connection oriented protocols normally hold on to a single route for the duration of a connection while connectionless protocols obtain a route while sending to the same destination. The use field provides a count of the number of packets sent using that route. The mtu entry shows the mtu associated with that route. This mtu value is used as the basis for the TCP maximum segment size. The 'L' flag appended to the mtu value indicates that the value is locked, and that path mtu discovery is turned off for that route. A ‘-’ indicates that the mtu for this route has not been set, and a default TCP maximum segment size will be used. The interface entry indicates the network interface utilized for the route.

When netstat is invoked with the -w option and a wait interval argument, it displays a running count of statistics related to network interfaces. An obsolescent version of this option used a numeric parameter with no option, and is currently supported for backward compatibility. This display consists of a column for the primary interface (the first interface found during autoconfiguration) and a column summarizing information for all interfaces. The primary interface may be replaced with another interface with the -I option. The first line of each screen of information contains a summary since the system was last rebooted. Subsequent lines of output show values accumulated over the preceding interval.

SEE ALSO
nfsstat(1), ps(1), hosts(5), networks(5), protocols(5), services(5), trpt(8), trsp(8), iostat(8), vmstat(8)

HISTORY
The netstat command appeared in 4.2BSD.

BUGS
The notion of errors is ill-defined.